Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/PerMessageDeflate.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/PerMessageDeflate.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/PerMessageDeflate.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.websocket;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.List;
@@ -207,11 +208,11 @@ public class PerMessageDeflate implement
             } catch (NullPointerException e) {
                 throw new IOException(sm.getString("perMessageDeflate.alreadyClosed"), e);
             }
-            dest.position(dest.position() + written);
+            ((Buffer)dest).position(dest.position() + written);
 
             if (inflater.needsInput() && !usedEomBytes ) {
                 if (dest.hasRemaining()) {
-                    readBuffer.clear();
+                    ((Buffer)readBuffer).clear();
                     TransformationResult nextResult =
                             next.getMoreData(opCode, fin, (rsv ^ RSV_BITMASK), readBuffer);
                     inflater.setInput(
@@ -355,7 +356,7 @@ public class PerMessageDeflate implement
                         int written = deflater.deflate(compressedPayload.array(),
                                 compressedPayload.arrayOffset() + compressedPayload.position(),
                                 compressedPayload.remaining(), flush);
-                        compressedPayload.position(compressedPayload.position() + written);
+                        ((Buffer)compressedPayload).position(compressedPayload.position() + written);
                     } catch (NullPointerException e) {
                         throw new IOException(sm.getString("perMessageDeflate.alreadyClosed"), e);
                     }
@@ -375,7 +376,7 @@ public class PerMessageDeflate implement
                     writeBuffer = ByteBuffer.allocate(Constants.DEFAULT_BUFFER_SIZE);
 
                     // Flip the compressed payload ready for writing
-                    compressedPayload.flip();
+                    ((Buffer)compressedPayload).flip();
 
                     boolean fin = uncompressedPart.isFin();
                     boolean full = compressedPayload.limit() == compressedPayload.capacity();
@@ -384,7 +385,7 @@ public class PerMessageDeflate implement
 
                     if (fin && !full && needsInput) {
                         // End of compressed message. Drop EOM bytes and output.
-                        compressedPayload.limit(compressedPayload.limit() - EOM_BYTES.length);
+                        ((Buffer)compressedPayload).limit(compressedPayload.limit() - EOM_BYTES.length);
                         compressedPart = new MessagePart(true, getRsv(uncompressedPart),
                                 opCode, compressedPayload, uncompressedIntermediateHandler,
                                 uncompressedIntermediateHandler, blockingWriteTimeoutExpiry);
@@ -419,7 +420,7 @@ public class PerMessageDeflate implement
                         }
                         if (eomBufferWritten < EOM_BUFFER.length) {
                             // EOM has just been completed
-                            compressedPayload.limit(compressedPayload.limit() - EOM_BYTES.length + eomBufferWritten);
+                            ((Buffer)compressedPayload).limit(compressedPayload.limit() - EOM_BYTES.length + eomBufferWritten);
                             compressedPart = new MessagePart(true,
                                     getRsv(uncompressedPart), opCode, compressedPayload,
                                     uncompressedIntermediateHandler, uncompressedIntermediateHandler,
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/server/WsFrameServer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/server/WsFrameServer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/server/WsFrameServer.java
@@ -19,6 +19,7 @@ package org.apache.tomcat.websocket.serv
 import java.io.EOFException;
 import java.io.IOException;
 import java.nio.ByteBuffer;
+import java.nio.Buffer;
 
 import org.apache.juli.logging.Log;
 import org.apache.juli.logging.LogFactory;
@@ -67,10 +68,10 @@ public class WsFrameServer extends WsFra
 
         while (isOpen() && !isSuspended()) {
             // Fill up the input buffer with as much data as we can
-            inputBuffer.mark();
-            inputBuffer.position(inputBuffer.limit()).limit(inputBuffer.capacity());
+            ((Buffer)inputBuffer).mark();
+            ((Buffer)inputBuffer).position(inputBuffer.limit()).limit(inputBuffer.capacity());
             int read = socketWrapper.read(false, inputBuffer);
-            inputBuffer.limit(inputBuffer.position()).reset();
+            ((Buffer)inputBuffer).limit(inputBuffer.position()).reset();
             if (read < 0) {
                 throw new EOFException();
             } else if (read == 0) {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsFrameBase.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/WsFrameBase.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsFrameBase.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.websocket;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.CharsetDecoder;
@@ -91,7 +92,7 @@ public abstract class WsFrameBase {
 
     public WsFrameBase(WsSession wsSession, Transformation transformation) {
         inputBuffer = ByteBuffer.allocate(Constants.DEFAULT_BUFFER_SIZE);
-        inputBuffer.position(0).limit(0);
+        ((Buffer)inputBuffer).position(0).limit(0);
         messageBufferBinary = ByteBuffer.allocate(wsSession.getMaxBinaryMessageBufferSize());
         messageBufferText = CharBuffer.allocate(wsSession.getMaxTextMessageBufferSize());
         wsSession.setWsFrame(this);
@@ -257,11 +258,11 @@ public abstract class WsFrameBase {
         if (payloadLength == 126) {
             payloadLength = byteArrayToLong(inputBuffer.array(),
                     inputBuffer.arrayOffset() + inputBuffer.position(), 2);
-            inputBuffer.position(inputBuffer.position() + 2);
+            ((Buffer)inputBuffer).position(inputBuffer.position() + 2);
         } else if (payloadLength == 127) {
             payloadLength = byteArrayToLong(inputBuffer.array(),
                     inputBuffer.arrayOffset() + inputBuffer.position(), 8);
-            inputBuffer.position(inputBuffer.position() + 8);
+            ((Buffer)inputBuffer).position(inputBuffer.position() + 8);
         }
         if (Util.isControl(opCode)) {
             if (payloadLength > 125) {
@@ -313,13 +314,13 @@ public abstract class WsFrameBase {
         // Control messages have fixed message size so
         // TransformationResult.OVERFLOW is not possible here
 
-        controlBufferBinary.flip();
+        ((Buffer)controlBufferBinary).flip();
         if (opCode == Constants.OPCODE_CLOSE) {
             open = false;
             String reason = null;
             int code = CloseCodes.NORMAL_CLOSURE.getCode();
             if (controlBufferBinary.remaining() == 1) {
-                controlBufferBinary.clear();
+                ((Buffer)controlBufferBinary).clear();
                 // Payload must be zero or 2+ bytes long
                 throw new WsIOException(new CloseReason(
                         CloseCodes.PROTOCOL_ERROR,
@@ -331,8 +332,8 @@ public abstract class WsFrameBase {
                     CoderResult cr = utf8DecoderControl.decode(controlBufferBinary,
                             controlBufferText, true);
                     if (cr.isError()) {
-                        controlBufferBinary.clear();
-                        controlBufferText.clear();
+                        ((Buffer)controlBufferBinary).clear();
+                        ((Buffer)controlBufferText).clear();
                         throw new WsIOException(new CloseReason(
                                 CloseCodes.PROTOCOL_ERROR,
                                 sm.getString("wsFrame.invalidUtf8Close")));
@@ -340,7 +341,7 @@ public abstract class WsFrameBase {
                     // There will be no overflow as the output buffer is big
                     // enough. There will be no underflow as all the data is
                     // passed to the decoder in a single call.
-                    controlBufferText.flip();
+                    ((Buffer)controlBufferText).flip();
                     reason = controlBufferText.toString();
                 }
             }
@@ -357,17 +358,17 @@ public abstract class WsFrameBase {
                 } catch (Throwable t) {
                     handleThrowableOnSend(t);
                 } finally {
-                    controlBufferBinary.clear();
+                    ((Buffer)controlBufferBinary).clear();
                 }
             }
         } else {
             // Should have caught this earlier but just in case...
-            controlBufferBinary.clear();
+            ((Buffer)controlBufferBinary).clear();
             throw new WsIOException(new CloseReason(
                     CloseCodes.PROTOCOL_ERROR,
                     sm.getString("wsFrame.invalidOpCode", Integer.valueOf(opCode))));
         }
-        controlBufferBinary.clear();
+        ((Buffer)controlBufferBinary).clear();
         newFrame();
         return true;
     }
@@ -397,7 +398,7 @@ public abstract class WsFrameBase {
         } catch (Throwable t) {
             handleThrowableOnSend(t);
         } finally {
-            messageBufferText.clear();
+            ((Buffer)messageBufferText).clear();
         }
     }
 
@@ -408,7 +409,7 @@ public abstract class WsFrameBase {
         while (!TransformationResult.END_OF_FRAME.equals(tr)) {
             // Frame not complete - we ran out of something
             // Convert bytes to UTF-8
-            messageBufferBinary.flip();
+            ((Buffer)messageBufferBinary).flip();
             while (true) {
                 CoderResult cr = utf8DecoderMessage.decode(messageBufferBinary, messageBufferText,
                         false);
@@ -419,9 +420,9 @@ public abstract class WsFrameBase {
                 } else if (cr.isOverflow()) {
                     // Ran out of space in text buffer - flush it
                     if (usePartial()) {
-                        messageBufferText.flip();
+                        ((Buffer)messageBufferText).flip();
                         sendMessageText(false);
-                        messageBufferText.clear();
+                        ((Buffer)messageBufferText).clear();
                     } else {
                         throw new WsIOException(new CloseReason(
                                 CloseCodes.TOO_BIG,
@@ -448,7 +449,7 @@ public abstract class WsFrameBase {
             tr = transformation.getMoreData(opCode, fin, rsv, messageBufferBinary);
         }
 
-        messageBufferBinary.flip();
+        ((Buffer)messageBufferBinary).flip();
         boolean last = false;
         // Frame is fully received
         // Convert bytes to UTF-8
@@ -462,9 +463,9 @@ public abstract class WsFrameBase {
             } else if (cr.isOverflow()) {
                 // Ran out of space in text buffer - flush it
                 if (usePartial()) {
-                    messageBufferText.flip();
+                    ((Buffer)messageBufferText).flip();
                     sendMessageText(false);
-                    messageBufferText.clear();
+                    ((Buffer)messageBufferText).clear();
                 } else {
                     throw new WsIOException(new CloseReason(
                             CloseCodes.TOO_BIG,
@@ -477,9 +478,9 @@ public abstract class WsFrameBase {
                     // If partial messages are supported, send what we have
                     // managed to decode
                     if (usePartial()) {
-                        messageBufferText.flip();
+                        ((Buffer)messageBufferText).flip();
                         sendMessageText(false);
-                        messageBufferText.clear();
+                        ((Buffer)messageBufferText).clear();
                     }
                     messageBufferBinary.compact();
                     newFrame();
@@ -491,7 +492,7 @@ public abstract class WsFrameBase {
                 }
             } else {
                 // End of message
-                messageBufferText.flip();
+                ((Buffer)messageBufferText).flip();
                 sendMessageText(true);
 
                 newMessage();
@@ -519,12 +520,12 @@ public abstract class WsFrameBase {
                                 Long.valueOf(payloadLength)));
                 throw new WsIOException(cr);
             }
-            messageBufferBinary.flip();
+            ((Buffer)messageBufferBinary).flip();
             ByteBuffer copy = ByteBuffer.allocate(messageBufferBinary.limit());
             copy.put(messageBufferBinary);
-            copy.flip();
+            ((Buffer)copy).flip();
             sendMessageBinary(copy, false);
-            messageBufferBinary.clear();
+            ((Buffer)messageBufferBinary).clear();
             // Read more data
             tr = transformation.getMoreData(opCode, fin, rsv, messageBufferBinary);
         }
@@ -534,12 +535,12 @@ public abstract class WsFrameBase {
         // - partial messages are supported
         // - the message is complete
         if (usePartial() || !continuationExpected) {
-            messageBufferBinary.flip();
+            ((Buffer)messageBufferBinary).flip();
             ByteBuffer copy = ByteBuffer.allocate(messageBufferBinary.limit());
             copy.put(messageBufferBinary);
-            copy.flip();
+            ((Buffer)copy).flip();
             sendMessageBinary(copy, !continuationExpected);
-            messageBufferBinary.clear();
+            ((Buffer)messageBufferBinary).clear();
         }
 
         if (continuationExpected) {
@@ -588,8 +589,8 @@ public abstract class WsFrameBase {
 
 
     private void newMessage() {
-        messageBufferBinary.clear();
-        messageBufferText.clear();
+        ((Buffer)messageBufferBinary).clear();
+        ((Buffer)messageBufferText).clear();
         utf8DecoderMessage.reset();
         continuationExpected = false;
         newFrame();
@@ -598,7 +599,7 @@ public abstract class WsFrameBase {
 
     private void newFrame() {
         if (inputBuffer.remaining() == 0) {
-            inputBuffer.position(0).limit(0);
+            ((Buffer)inputBuffer).position(0).limit(0);
         }
 
         maskIndex = 0;
@@ -631,7 +632,7 @@ public abstract class WsFrameBase {
 
     private void makeRoom() {
         inputBuffer.compact();
-        inputBuffer.flip();
+        ((Buffer)inputBuffer).flip();
     }
 
 
@@ -649,7 +650,7 @@ public abstract class WsFrameBase {
 
     private boolean swallowInput() {
         long toSkip = Math.min(payloadLength - payloadWritten, inputBuffer.remaining());
-        inputBuffer.position(inputBuffer.position() + (int) toSkip);
+        ((Buffer)inputBuffer).position(inputBuffer.position() + (int) toSkip);
         payloadWritten += toSkip;
         if (payloadWritten == payloadLength) {
             if (continuationExpected) {
@@ -945,9 +946,9 @@ public abstract class WsFrameBase {
             toWrite = Math.min(toWrite, dest.remaining());
 
             int orgLimit = inputBuffer.limit();
-            inputBuffer.limit(inputBuffer.position() + (int) toWrite);
+            ((Buffer)inputBuffer).limit(inputBuffer.position() + (int) toWrite);
             dest.put(inputBuffer);
-            inputBuffer.limit(orgLimit);
+            ((Buffer)inputBuffer).limit(orgLimit);
             payloadWritten += toWrite;
 
             if (payloadWritten == payloadLength) {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsFrameClient.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/WsFrameClient.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsFrameClient.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.websocket;
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 
@@ -76,8 +77,8 @@ public class WsFrameClient extends WsFra
                         // and then a new socket read will be performed
                         return;
                     }
-                    inputBuffer.mark();
-                    inputBuffer.position(inputBuffer.limit()).limit(inputBuffer.capacity());
+                    ((Buffer)inputBuffer).mark();
+                    ((Buffer)inputBuffer).position(inputBuffer.limit()).limit(inputBuffer.capacity());
 
                     int toCopy = Math.min(response.remaining(), inputBuffer.remaining());
 
@@ -85,16 +86,16 @@ public class WsFrameClient extends WsFra
                     // frame processing
 
                     int orgLimit = response.limit();
-                    response.limit(response.position() + toCopy);
+                    ((Buffer)response).limit(response.position() + toCopy);
                     inputBuffer.put(response);
-                    response.limit(orgLimit);
+                    ((Buffer)response).limit(orgLimit);
 
-                    inputBuffer.limit(inputBuffer.position()).reset();
+                    ((Buffer)inputBuffer).limit(inputBuffer.position()).reset();
 
                     // Process the data we have
                     processInputBuffer();
                 }
-                response.clear();
+                ((Buffer)response).clear();
 
                 // Get some more data
                 if (isOpen()) {
@@ -159,7 +160,7 @@ public class WsFrameClient extends WsFra
                 // No data to process
                 return;
             }
-            response.flip();
+            ((Buffer)response).flip();
             doResumeProcessing(true);
         }
 
@@ -169,7 +170,7 @@ public class WsFrameClient extends WsFra
                 // response will be empty if this exception is thrown
                 response = ByteBuffer
                         .allocate(((ReadBufferOverflowException) exc).getMinBufferSize());
-                response.flip();
+                ((Buffer)response).flip();
                 doResumeProcessing(false);
             } else {
                 close(exc);
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsRemoteEndpointImplBase.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/WsRemoteEndpointImplBase.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsRemoteEndpointImplBase.java
@@ -20,6 +20,7 @@ import java.io.IOException;
 import java.io.OutputStream;
 import java.io.Writer;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.CharsetEncoder;
@@ -240,13 +241,13 @@ public abstract class WsRemoteEndpointIm
         long timeoutExpiry = getTimeoutExpiry();
         boolean isDone = false;
         while (!isDone) {
-            encoderBuffer.clear();
+            ((Buffer)encoderBuffer).clear();
             CoderResult cr = encoder.encode(part, encoderBuffer, true);
             if (cr.isError()) {
                 throw new IllegalArgumentException(cr.toString());
             }
             isDone = !cr.isOverflow();
-            encoderBuffer.flip();
+            ((Buffer)encoderBuffer).flip();
             sendMessageBlock(Constants.OPCODE_TEXT, encoderBuffer, last && isDone, timeoutExpiry);
         }
         stateMachine.complete(last);
@@ -321,7 +322,7 @@ public abstract class WsRemoteEndpointIm
         }
 
         if (payload != null) {
-            payload.clear();
+            ((Buffer)payload).clear();
         }
 
         endMessage(null, null);
@@ -433,7 +434,7 @@ public abstract class WsRemoteEndpointIm
         if (Constants.INTERNAL_OPCODE_FLUSH == mp.getOpCode()) {
             nextFragmented = fragmented;
             nextText = text;
-            outputBuffer.flip();
+            ((Buffer)outputBuffer).flip();
             SendHandler flushHandler = new OutputBufferFlushSendHandler(
                     outputBuffer, mp.getEndHandler());
             doWrite(flushHandler, mp.getBlockingWriteTimeoutExpiry(), outputBuffer);
@@ -482,10 +483,10 @@ public abstract class WsRemoteEndpointIm
             mask = null;
         }
 
-        headerBuffer.clear();
+        ((Buffer)headerBuffer).clear();
         writeHeader(headerBuffer, mp.isFin(), mp.getRsv(), mp.getOpCode(),
                 isMasked(), mp.getPayload(), mask, first);
-        headerBuffer.flip();
+        ((Buffer)headerBuffer).flip();
 
         if (getBatchingAllowed() || isMasked()) {
             // Need to write via output buffer
@@ -798,13 +799,13 @@ public abstract class WsRemoteEndpointIm
         }
 
         public void write() {
-            buffer.clear();
+            ((Buffer)buffer).clear();
             CoderResult cr = encoder.encode(message, buffer, true);
             if (cr.isError()) {
                 throw new IllegalArgumentException(cr.toString());
             }
             isDone = !cr.isOverflow();
-            buffer.flip();
+            ((Buffer)buffer).flip();
             endpoint.startMessage(Constants.OPCODE_TEXT, buffer,
                     isDone && isLast, this);
         }
@@ -865,7 +866,7 @@ public abstract class WsRemoteEndpointIm
             }
             if (headerBuffer.hasRemaining()) {
                 // Still more headers to write, need to flush
-                outputBuffer.flip();
+                ((Buffer)outputBuffer).flip();
                 endpoint.doWrite(this, blockingWriteTimeoutExpiry, outputBuffer);
                 return;
             }
@@ -879,7 +880,7 @@ public abstract class WsRemoteEndpointIm
             if (payloadLeft > outputSpace) {
                 toWrite = outputSpace;
                 // Temporarily reduce the limit
-                payload.limit(payload.position() + toWrite);
+                ((Buffer)payload).limit(payload.position() + toWrite);
             }
 
             if (mask == null) {
@@ -897,15 +898,15 @@ public abstract class WsRemoteEndpointIm
 
             if (payloadLeft > outputSpace) {
                 // Restore the original limit
-                payload.limit(payloadLimit);
+                ((Buffer)payload).limit(payloadLimit);
                 // Still more data to write, need to flush
-                outputBuffer.flip();
+                ((Buffer)outputBuffer).flip();
                 endpoint.doWrite(this, blockingWriteTimeoutExpiry, outputBuffer);
                 return;
             }
 
             if (flushRequired) {
-                outputBuffer.flip();
+                ((Buffer)outputBuffer).flip();
                 if (outputBuffer.remaining() == 0) {
                     handler.onResult(SENDRESULT_OK);
                 } else {
@@ -923,7 +924,7 @@ public abstract class WsRemoteEndpointIm
                 if (outputBuffer.hasRemaining()) {
                     endpoint.doWrite(this, blockingWriteTimeoutExpiry, outputBuffer);
                 } else {
-                    outputBuffer.clear();
+                    ((Buffer)outputBuffer).clear();
                     write();
                 }
             } else {
@@ -949,7 +950,7 @@ public abstract class WsRemoteEndpointIm
         @Override
         public void onResult(SendResult result) {
             if (result.isOK()) {
-                outputBuffer.clear();
+                ((Buffer)outputBuffer).clear();
             }
             handler.onResult(result);
         }
@@ -1042,11 +1043,11 @@ public abstract class WsRemoteEndpointIm
 
         private void doWrite(boolean last) throws IOException {
             if (used) {
-                buffer.flip();
+                ((Buffer)buffer).flip();
                 endpoint.sendMessageBlock(Constants.OPCODE_BINARY, buffer, last);
             }
             endpoint.stateMachine.complete(last);
-            buffer.clear();
+            ((Buffer)buffer).clear();
         }
     }
 
@@ -1121,9 +1122,9 @@ public abstract class WsRemoteEndpointIm
 
         private void doWrite(boolean last) throws IOException {
             if (used) {
-                buffer.flip();
+                ((Buffer)buffer).flip();
                 endpoint.sendMessageBlock(buffer, last);
-                buffer.clear();
+                ((Buffer)buffer).clear();
             } else {
                 endpoint.stateMachine.complete(last);
             }
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsSession.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/WsSession.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsSession.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.websocket;
 
 import java.io.IOException;
 import java.net.URI;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.WritePendingException;
 import java.nio.charset.StandardCharsets;
@@ -607,7 +608,7 @@ public class WsSession implements Sessio
         if (reason != null && reason.length() > 0) {
             appendCloseReasonWithTruncation(msg, reason);
         }
-        msg.flip();
+        ((Buffer)msg).flip();
         try {
             wsRemoteEndpoint.sendMessageBlock(Constants.OPCODE_CLOSE, msg, true);
         } catch (IOException | WritePendingException e) {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsWebSocketContainer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/WsWebSocketContainer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/WsWebSocketContainer.java
@@ -27,6 +27,7 @@ import java.net.ProxySelector;
 import java.net.SocketAddress;
 import java.net.URI;
 import java.net.URISyntaxException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.AsynchronousChannelGroup;
 import java.nio.channels.AsynchronousSocketChannel;
@@ -742,7 +743,7 @@ public class WsWebSocketContainer implem
         // Terminating CRLF
         result.put(CRLF);
 
-        result.flip();
+        ((Buffer)result).flip();
 
         return result;
     }
@@ -771,7 +772,7 @@ public class WsWebSocketContainer implem
                 newSize = input.capacity() * 2;
             }
             ByteBuffer expanded = ByteBuffer.allocate(newSize);
-            input.flip();
+            ((Buffer)input).flip();
             expanded.put(input);
             input = expanded;
         }
@@ -800,14 +801,14 @@ public class WsWebSocketContainer implem
         while (!readHeaders) {
             // On entering loop buffer will be empty and at the start of a new
             // loop the buffer will have been fully read.
-            response.clear();
+            ((Buffer)response).clear();
             // Blocking read
             Future<Integer> read = channel.read(response);
             Integer bytesRead = read.get(timeout, TimeUnit.MILLISECONDS);
             if (bytesRead.intValue() == -1) {
                 throw new EOFException();
             }
-            response.flip();
+            ((Buffer)response).flip();
             while (response.hasRemaining() && !readHeaders) {
                 if (line == null) {
                     line = readLine(response);
Index: apache-tomcat-9.0.33-src/test/org/apache/coyote/http11/upgrade/TestUpgradeInternalHandler.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/coyote/http11/upgrade/TestUpgradeInternalHandler.java
+++ apache-tomcat-9.0.33-src/test/org/apache/coyote/http11/upgrade/TestUpgradeInternalHandler.java
@@ -25,6 +25,7 @@ import java.io.OutputStreamWriter;
 import java.io.PrintWriter;
 import java.io.Writer;
 import java.net.Socket;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 import java.nio.charset.StandardCharsets;
@@ -210,7 +211,7 @@ public class TestUpgradeInternalHandler
         }
 
         private void write(ByteBuffer buffer) {
-            buffer.flip();
+            ((Buffer)buffer).flip();
             CompletionState state = wrapper.write(BlockingMode.BLOCK, 10, TimeUnit.SECONDS, null, SocketWrapperBase.COMPLETE_WRITE, new CompletionHandler<Long, Void>() {
                 @Override
                 public void completed(Long result, Void attachment) {
